import * as d3 from 'd3';

var data = {
  name: 'A1',
  children: [
    {
      name: 'B1',
      children: [
        {
          name: 'C1',
          value: 100,
        },
        {
          name: 'C2',
          value: 300,
        },
        {
          name: 'C3',
          value: 200,
        },
      ],
    },
    {
      name: 'B2',
      value: 200,
    },
  ],
};

export const main = (container) => {
  const width = container.clientWidth;
  const height = container.clientHeight;

  var packLayout = d3.pack().size([300, 300]);

  var rootNode = d3.hierarchy(data);
  rootNode.sum((d) => d.value);

  packLayout(rootNode);

  const svg = d3
    .select(container)
    .selectAll('svg')
    .data([1])
    .join('svg')
    .attr('width', width)
    .attr('height', height);

  var nodes = svg
    .selectAll('g')
    .data(rootNode.descendants())
    .join('g')
    .style(
      'transform',
      (d) => `translate(${d.x}px, ${d.y}px)`,
    );

  nodes
    .append('circle')
    .attr('r', (d) => d.r)
    // .style('fill', 'indianred')
    .style('opacity', 0.3)
    .style('stroke', 'white');

  nodes
    .append('text')
    .attr('dy', 4)
    .text((d) =>
      d.children === undefined ? d.data.name : '',
    )
    .style('fill', 'white')
    .style('font-size', '10px')
    .style('text-anchor', 'middle');
};
